uniform mat4 modelViewProjectionMatrix;
uniform mat4 modelViewMatrix;
uniform mat4 lightViewProjectionMatrix; // modelviewprojection(and bias) for rendered shadowmap
attribute vec4 vPosition;
attribute vec3 vNormal;
attribute vec2 vTexCoord;

varying vec2 uvCoords;
varying vec4 shadowCoord;
varying float lightingCoefficient;

vec3 lightDir = vec3(0.400000, 0.800000, -0.600000);

void main()
{
    // lighting
    mat3 rotMat = mat3(modelViewMatrix[0].xyz, modelViewMatrix[1].xyz, modelViewMatrix[2].xyz);
    vec3 normalEyeSpace = rotMat * vNormal;
    vec3 lightEyeSpace = vec3(rotMat * lightDir);
    lightingCoefficient = max(dot(normalEyeSpace, lightEyeSpace), 0.0);

    // shadowing
    shadowCoord = lightViewProjectionMatrix * vPosition;

    // texture
    uvCoords = vTexCoord;

    // position
    gl_Position = modelViewProjectionMatrix * vPosition;
}
